import { deserialize } from './de'
import { fromString, toString } from './json'
import { serialize } from './ser'

const InnerStruct = deserialize()(
  @serialize()
    class {
    c = 'awawa'
  })

const TestStruct = deserialize()(
  @serialize()
    class {
    a = 1
    b
    inner = new InnerStruct()
    d = true
    e = Math.pow(2, 53)
    f = Symbol('test')
    g = [1, 'a', [3]]

    constructor() {
      this.b = new Map()
      this.b.set('test key', 2)
    }
  })

const test = new TestStruct()
const value = toString(test)
console.log(value)
const test2 = fromString(value, TestStruct)
console.log(test2)

